/** @file
 */
#if !defined(__GDESTRAIER__BUILDER__ID3_FILTER__HPP__)
#define __GDESTRAIER__BUILDER__ID3_FILTER__HPP__

#include "filter.hpp"

namespace gdestraier {
  namespace builder {
    namespace filter {

      class from_id3 : public abstract_filter
      {
      public:
        from_id3();
        virtual ~from_id3();

        virtual bool operator() (hyperestraier::local_document* doc,
                                 gdestraier::model::index_type const& index,
                                 ::GnomeVFSURI* uri,
                                 char const* text_ur,
                                 ::GnomeVFSFileInfo* info,
                                 char const* mime_type) const;

        static factory const& get_factory();
        static abstract_filter* create();

      protected:
        static factory::extention_map_type extentions_[];
      };


    }
  }
}


#endif
